const chalk = require("chalk")
const fs = require("fs")
const path = require("path")

function cacheToFile(word, explans) {
    let url = path.join(process.cwd(), "cache/" + word + ".json")
    try {
        fs.mkdirSync(path.join(process.cwd(), "cache"))
    } catch (err) {

    } finally {
        fs.writeFile(url, Buffer.from(JSON.stringify(explans)), (err) => {
            if (err) {
                console.log(err)
            }
        })
    }
}

module.exports = function (word, explans, cache) {
    console.log(`# ${chalk.red(word)}${chalk.gray(cache ? " (use cache)" : " (cached)")}: `)
    if (Array.isArray(explans)) {
        explans.forEach((ele, index) => {
            if (ele.prop) {
                let prop = ele.prop.padStart(8, " ")
                console.log(`${chalk.green(prop)}: ${ele.desc}`)
            }
        })
        !cache && explans.length > 0 && cacheToFile(word, explans)
    }
}
